//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
//

#include "Crea_matriz.h"

Define_Module(Crea_matriz);


int Crea_matriz::numInitStages() const{return 2;}

void Crea_matriz::initialize(int stage)
{
	if(stage==1)
	{
		int i;

		num_nodos=par("num_nodos");
		carga=par("carga");
		tasa=par("tasa");

		bits_segundo=(tasa*carga);


		rng1 = getRNG(0);

		matriz_trafico.resize(num_nodos);
		for(i=0;i<(signed)matriz_trafico.size();i++)matriz_trafico[i].resize(num_nodos, 0.0);


		if((bool)(getParentModule()->getParentModule()->getParentModule()->par("semi_static")))
		{
            cMessage * msg= new cMessage ("GENERA MATRIZ TRAFICO",GENERAMATRIZ);
            scheduleAt(simTime(),msg);
		}

	}

}

void Crea_matriz::handleMessage(cMessage *msg)
{

	int i,j,k;
	MatrizTrafico *paquete;

	switch (msg->getKind())
	{
		case GENERAMATRIZ:     //Este mensaje va a generar matrices de trafico

			for(k=0;k<1;k++)
			{
				for (i=0;i<num_nodos;i++)
				{
					for(j=0;j<num_nodos;j++)
					{
						if(i==j)matriz_trafico[i][j]=0;
						else matriz_trafico[i][j]=2*bits_segundo*rng1->doubleRandIncl1();
					}
				}
			}

			paquete=new MatrizTrafico("MATRIZ DE TRAFICO",TRAFICO);
			paquete->setTraficoArraySize(num_nodos*num_nodos);

			for (i=0;i<num_nodos;i++)
			{
				for(j=0;j<num_nodos;j++)
				{
					paquete->setTrafico((i*num_nodos)+j,(matriz_trafico[i][j]));
				}
			}

			send(paquete,"out");

			delete(msg);

			break;
	};

}



