//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "HLDA.h"

Define_Module(HLDA);

void HLDA::initialize()
{
    num_nodos=(int)par("num_nodos");
    numeroLightpaths=0;
    num_tx_por_edge_router=(int)par("num_tx_por_edge_router");
    num_lng_ond=(int)par("num_lng_ond");
    tasa =(double)par("tasa");

    cModule* c_modulo_estado;
    c_modulo_estado = getParentModule()->getParentModule()->getSubmodule("estado");
    modulo_estado = check_and_cast<Estado *>(c_modulo_estado);


}

void HLDA::handleMessage(cMessage *msg)
{

    MatrizTrafico * matriz_trafico_msg;
    char estado_mostrar[10000];
    char auxiliarParaEscribir[100];
    char auxiliardos[500];


    double_matrix_t matriz_trafico;
    matriz_trafico.resize(num_nodos);

    for(int i=0; i< num_nodos; i++)
    {
        matriz_trafico[i].resize(num_nodos);

    }
    switch(msg->getKind())
    {
    case TRAFICO:
    {

        matriz_trafico_msg=check_and_cast <MatrizTrafico *> (msg);


        ev<<"ESTA ES LA MATRIZ DE TRAFICO PARA DISEAR LA TOPOLOGA VIRTUAL"<<endl;

        ev<<"Desde nodo :"<<"\t";
        for(int i=0; i<num_nodos; i++)
        {
            ev<<i<<"\t\t";
        }
        ev<<endl;
        for(int i=0; i<num_nodos; i++)
        {
            ev<<"hasta nodo:"<<"\t"<<i<<"\t";

            for(int j=0; j<num_nodos; j++)
            {
                matriz_trafico[i][j]=(matriz_trafico_msg->getTrafico((i*(num_nodos)+j))/1e9); //Gigas por segundo

                ev<<matriz_trafico[i][j]<<"\t\t";

            }
            ev<<endl;
        }


//        numeroLightpaths++;
//        topologia_virtual.resize(numeroLightpaths);
//        topologia_virtual[numeroLightpaths-1].resize((num_nodos+3),-1);

        ev<<"TOPOLOGIA VIRTUAL DISEADA "<<endl;
        ev<<"Origen\tDestino\tLambda\tEnlaces"<<endl;
        for(int i=0; i<numeroLightpaths; i++)
        {

            for(int j=0; j<topologia_virtual[i].size(); j++)
                ev<<topologia_virtual[i][j]<<"\t";
            ev<<endl;
        }

        congestion=calcularCongestion(topologia_virtual,matriz_trafico);

        ev<<"La congestion es: "<<congestion<<endl;









        for (int i=0;i<num_nodos;i++)
        {
            cDisplayString& dispStrcinco = getParentModule()->getParentModule()->getParentModule()->getSubmodule("nodo",i)->getDisplayString();
            dispStrcinco.insertTag("t");
            sprintf(auxiliarParaEscribir," %d / %d",modulo_estado->tablatxrx[i][0],modulo_estado->tablatxrx[i][1]);
            dispStrcinco.setTagArg("t",0,auxiliarParaEscribir);
            dispStrcinco.setTagArg("t",1,"r");
        }



        sprintf(estado_mostrar,"ESTADO DE LOS CANALES\n");
        strcat(estado_mostrar,"      \t");

        for(int i=0;i<num_lng_ond;i++)
        {
            sprintf(auxiliarParaEscribir,"%4d",i);
            strcat(estado_mostrar,auxiliarParaEscribir);
        }
        strcat(estado_mostrar,"\n\n");

        for(int i=0;i<modulo_estado->num_enlaces;i++)
        {
            sprintf(auxiliarParaEscribir,"%2d->%2d  ",simulation.getModule(modulo_estado->tabla_enlaces[i][1])->getIndex(),simulation.getModule(modulo_estado->tabla_enlaces[i][2])->getIndex());
            strcat(estado_mostrar,auxiliarParaEscribir);
            for(int j=0;j<num_lng_ond;j++)
            {
                 sprintf(auxiliarParaEscribir,"%4d",modulo_estado->estado[i][j]);
                 strcat(estado_mostrar,auxiliarParaEscribir);
            }
            strcat(estado_mostrar,"\n");
        }



        cDisplayString& dispStr = getParentModule()->getParentModule()->getParentModule()->getSubmodule("texto")->getDisplayString();
        dispStr.setTagArg("t",0,estado_mostrar);








        break;
    }

    }
}





double HLDA::calcularCongestion(int_matrix_t topVirtual, double_matrix_t matriz_trafico)
{
    double cong=0.0;


    double_vector_t linksList;
    cModule *parent = getParentModule()->getParentModule()->getParentModule();



    cTopologyExtension graph;
    cModule *submod;
    cTopologyExtension::NodeExtension *sourceNode, *destinonod;

    int sourceIndex,destinationIndex;
    double trafficPerLink;

    int distance;
    int numPaths;
    int i,j,k,r,t;
    double total;
    int moreThanOneLightpath;


    linksList.resize(numeroLightpaths);

    for(i=0;i<numeroLightpaths;i++)linksList[i]=0.0;
    const char * name;


        graph.virtualExtractByNedTypeName(cStringTokenizer("simuladorWRON.src.CoreRouters.CoreRouter").asVector(), topologia_virtual, numeroLightpaths);
        name="nodo";





    for(i=0;i<num_nodos;i++)
    {
        submod = parent->getSubmodule(name,i);
        destinonod= graph.getNodeFor(submod);
        graph.calculateUnweightedMultipleShortestPathsTo(destinonod);

        for(j=0;j<num_nodos;j++)
        {

            submod = parent->getSubmodule(name,j);
            sourceNode= graph.getNodeFor(submod);

            total= total + matriz_trafico[j][i];

            if((i!=j)&&(sourceNode->getDistanceToTarget()!=HUGE_VAL))
            {

                trafficPerLink = matriz_trafico[j][i]/(double)sourceNode->numPaths_m();

                numPaths=(int)sourceNode->numPaths_m();
                for(k=0;k<numPaths;k++)
                {
                    sourceIndex=j;
                    submod = parent->getSubmodule(name,sourceIndex);
                    sourceNode= graph.getNodeFor(submod);

                    distance=(int)sourceNode->getDistanceToTarget();

                    for(r=0;r<distance;r++)
                    {

                        submod = parent->getSubmodule(name,sourceIndex);
                        sourceNode= graph.getNodeFor(submod);

                        destinationIndex=sourceNode->paths_m(k)->getModule()->getIndex();

                        moreThanOneLightpath = 0;

                        for(t=0;t<numeroLightpaths;t++)
                        {

                            if((topologia_virtual[t][0]==sourceIndex)&&(topologia_virtual[t][1]==destinationIndex))
                            {

                                linksList[t]=linksList[t]+trafficPerLink;
                                moreThanOneLightpath++;

                            }
                        }

                        if(moreThanOneLightpath>1)
                        {

                            for(t=0;t<numeroLightpaths;t++)
                            {

                                if((topologia_virtual[t][0]==sourceIndex)&&(topologia_virtual[t][1]==destinationIndex))
                                {
                                    linksList[t]=linksList[t]-trafficPerLink;
                                    linksList[t]=linksList[t]+(trafficPerLink/(double)moreThanOneLightpath);

                                }
                            }
                        }


                        sourceIndex=destinationIndex;


                    }
                }
            }
            else if((i!=j)&&(sourceNode->getDistanceToTarget()==HUGE_VAL))
            {
                cong=HUGE_VAL;
                i=num_nodos;
                j=num_nodos;

            }

        }

    }



    for(t=0;t<numeroLightpaths;t++)
    {
        if(linksList[t]>cong)cong=linksList[t];
    }




    cong=(cong*1e9)/tasa;






    return cong;
}
